
Graphics3D 1024,768,0,2
SetBuffer BackBuffer()

Dim PrevMouseDown%(3)

AppTitle "SCP-CB Map Creator (WYSIWYG)"

Const ROOM1% = 1, ROOM2% = 2, ROOM2C% = 3, ROOM3% = 4, ROOM4% = 5

Global light = CreateLight()
Global D3DMode% = False
RotateEntity light,90,0,0

Global Camera% = CreateCamera()
MoveEntity Camera,0,1,0
Global RoomScale# = 8.0/2048.0
Global CamRange# = 2500*RoomScale
CameraFogColor Camera,0,0,0
CameraFogMode Camera,1
CameraViewport Camera,0,0,496,496

Global ForceRender = False

;If CheckFPS < MilliSecs() Then
;		FPS = ElapsedLoops
;		ElapsedLoops = 0
;		CheckFPS = MilliSecs()+1000
;	EndIf
Global CheckFPS%,ElapsedLoops%,FPS%

Global Render3D% = CreateImage(496,496)

Global CenterSphere% = CreateSphere()
ScaleEntity CenterSphere,RoomScale*50,RoomScale*50,RoomScale*50
EntityFX CenterSphere,0
EntityColor CenterSphere,50,100,50
EntityAlpha CenterSphere,0

Global CameraPitch# = 0.0
Global CameraYaw# = 0.0

Global FocusCamera% = False

Global RoomTempID%
Type RoomTemplates
	Field Shape%, Name$
	Field Description$
	Field Large%
	Field id
	Field obj
	
	Field events$[5]
End Type 	

Function CreateRoomTemplate.RoomTemplates(meshpath$)
	Local rt.RoomTemplates = New RoomTemplates
	
	rt\id = RoomTempID
	RoomTempID=RoomTempID+1
	
	Return rt
End Function

Function LoadRoomTemplates(file$)
	Local TemporaryString$, Temp%, i%, n%
	Local rt.RoomTemplates = Null
	Local StrTemp$ = ""
	
	Local f = OpenFile(file)
	
	ClsColor 0,0,0
	
	Local oldtime% = MilliSecs()
	Local totaltimes% = 0
	
	While Not Eof(f)
		TemporaryString = Trim(ReadLine(f))
		If Left(TemporaryString,1) = "[" Then
			TemporaryString = Mid(TemporaryString, 2, Len(TemporaryString) - 2)
			
			If TemporaryString <> "room ambience" Then
				rt = CreateRoomTemplate(StrTemp)
				rt\Name = TemporaryString
				
				;rt\obj = LoadRoomMesh(rt\Name,"..\"+GetINIString(file,TemporaryString,"mesh path"))
				
				tempStr$=GetINIString(file,TemporaryString,"mesh path")
				
				DebugLog tempStr
				
				If Instr(tempStr,".rmesh")<>0 Then ;file is roommesh
					rt\obj = LoadRoomMeshNew(rt\Name,"..\"+tempStr)
				Else ;file is b3d
					If tempStr <> "" Then rt\obj = LoadRoomMesh(rt\Name,"..\"+tempStr); Else rt\obj = CreatePivot()
				EndIf
				If (Not rt\obj) Then RuntimeError "Failed to load map file "+Chr(34)+tempStr+Chr(34)+"."
				
				DebugLog "done"
				
				EntityPickMode rt\obj,2
				
				;EntityFX rt\obj,1
				
				ScaleMesh rt\obj,RoomScale,RoomScale,RoomScale
				ScaleMesh GetChild(rt\obj,1),RoomScale,RoomScale,RoomScale
				
				Cls
				;RenderWorld
				HideEntity rt\obj
				HideEntity GetChild(rt\obj,1)
				totaltime = totaltime+MilliSecs()-oldtime
				;Color 0,0,0
				;For tInt=0 To 3
				;	For tInt2=0 To 3
				;		Text 50-1+tInt,50-1+tInt2,"Loaded "+rt\Name
				;		Text 50-1+tInt, 70-1+tInt2,"in "+Str(MilliSecs()-oldtime)+" milliseconds."
				;		Text 50-1+tInt,90-1+tInt2,Str(totaltime)+" milliseconds in total."
				;	Next
				;Next
				Color 255,255,255
				Text 50,50,"Loaded "+rt\Name
				Text 50, 70,"in "+Str(MilliSecs()-oldtime)+" milliseconds."
				Text 50,90,Str(totaltime)+" milliseconds in total."
				oldtime = MilliSecs()
				Flip
				
				
				StrTemp = Lower(GetINIString(file, TemporaryString, "shape"))
				Select StrTemp
					Case "room1", "1"
						rt\Shape = ROOM1
					Case "room2", "2"
						rt\Shape = ROOM2
					Case "room2c", "2c", "2c"
						rt\Shape = ROOM2C
					Case "room3", "3"
						rt\Shape = ROOM3
					Case "room4", "4"
						rt\Shape = ROOM4
					Default
				End Select
				
				rt\Description = GetINIString(file, TemporaryString, "descr")
				rt\Large = GetINIInt(file, TemporaryString, "large")
				
			EndIf
			
		EndIf
	Wend
	
	CloseFile f
	
End Function

Function InitEvents()
	For rt.roomtemplates = Each RoomTemplates
		Select rt\name
			Case "173"
				rt\events[0]="173"
			Case "008"
				rt\events[0]="008"
			Case "914"
				rt\events[0]="914"
			Case "coffin"
				rt\events[0]="coffin"
				rt\events[1]="coffin106"
			Case "gatea"
				rt\events[0]="gatea"	
			Case "gateaentrance"
				rt\events[0]="gateaentrance"	
			Case "exit1"
				rt\events[0]="exit1"	
			Case "endroom"
				rt\events[0]="endroom106"	
			Case "start"
				rt\events[0]="alarm"	
			Case "pocketdimension"
				rt\events[0]="pocketdimension"
			Case "checkpoint1","checkpoint2"
				rt\events[0]="checkpoint"
			Case "lockroom"
				rt\events[0]="lockroom173"
			Case "lockroom2"
				rt\events[0]="lockroom096"	
			Case "testroom"
				rt\events[0]="testroom"
			Case "tunnel2"
				rt\events[0]="tunnel2"
				rt\events[1]="tunnel2smoke"
			Case "roompj"
				rt\events[0]="pj"
			Case "room012"
				rt\events[0]="room012"
			Case "room035"
				rt\events[0]="room035"
			Case "room049"
				rt\events[0]="room049"
			Case "room079"
				rt\events[0]="room079"
			Case "room106"
				rt\events[0]="room106"
			Case "room2"
				rt\events[0]="room2trick"
			Case "room2_2"
				rt\events[0]="room2fan"			
			Case "room2cafeteria"
				rt\events[0]="room2cafeteria"						
			Case "room2ccont"
				rt\events[0]= "room2ccont"
			Case "room2closets"
				rt\events[0]="room2closets"
			Case "room2doors"
				rt\events[0]="room2doors173"
			Case "room2elevator"
				rt\events[0]="room2elevator"
			Case "room2nuke"
				rt\events[0]="room2nuke"
			Case "room2offices2"
				rt\events[0]="room2offices2"
			Case "room2offices3"
				rt\events[0]="room2offices3"
			Case "room2pipes"
				rt\events[0]="room2pipes106"	
			Case "room2pit"
				rt\events[0]="room2pit"	
			Case "room2poffices2"
				rt\events[0]="room2poffices2"					
			Case "room2servers"
				rt\events[0]="room2servers"
			Case "room2storage"
				rt\events[0]="room2storage"
			Case "room2tesla","room2tesla_lcz","room2tesla_hcz"
				rt\events[0]="room2tesla"	
			Case "room2testroom2"
				rt\events[0]="testroom173"	
			Case "room2toilets"
				rt\events[0]="toiletguard"	
				rt\events[1]="buttghost"	
			Case "room2tunnel"
				rt\events[0]="room2tunnel"	
			Case "room3", "room3tunnel"
				rt\events[0]="room3door"				
			Case "room3servers","room3servers2"
				rt\events[0]="room3servers"
			Case "room3storage"
				rt\events[0]="room3storage"
			Case "room3pit"
				rt\events[0]="room3pit"
			Case "room3tunnel"
				rt\events[0]="room3tunnel"
			Case "room3","room3_2" 
				rt\events[0]="106victim"
			Case "room4"
				rt\events[0]="room4"
			Case "room860"
				rt\events[0]="room860"
			Case "tunnel"
				rt\events[0]="tunnel106"
			;Box of Horrors support:
			Case "room009"
				rt\events[0]="room009"
			Case "room038"
				rt\events[0]="room038"
			Case "room2test1074"
				rt\events[0]="room2test1074"
			Case "room1123"
				rt\events[0]="room1123"
			Case "room409"
				rt\events[0]="room409"
			Case "room178"
				rt\events[0]="room178"
			Case "room020"
				rt\events[0]="room020"
		End Select
	Next
	
End Function

ChangeDir ".."
ChangeDir ".." ;needed twice for BoH

Global Font1 = LoadFont("GFX\TI-83.ttf", 16)
Global ButtonSFX% = LoadSound("SFX\button.ogg")


ChangeDir "Map Creator"
SetFont Font1

Local OldDir$ = CurrentDir()

Dim MapIcons(5,4)
MapIcons(ROOM1, 0)=LoadImage("room1.png")
MapIcons(ROOM2, 0)=LoadImage("room2.png")
MapIcons(ROOM2C, 0)=LoadImage("room2C.png")
MapIcons(ROOM3, 0)=LoadImage("room3.png")
MapIcons(ROOM4, 0)=LoadImage("room4.png")

For i = ROOM1 To ROOM4
	MaskImage MapIcons(i,0), 255,255,255
	HandleImage MapIcons(i,0),8,8
	For n = 1 To 3
		MapIcons(i,n)=CopyImage(MapIcons(i,0))
		MaskImage MapIcons(i,n), 255,255,255
		RotateImage(MapIcons(i,n),90*n)
		If n = 2 
			HandleImage MapIcons(i,n),9,9
		Else
			HandleImage MapIcons(i,n),8,8
		EndIf
	Next
Next

Dim Arrows(4)
Arrows(0) = LoadImage("arrows.png")
HandleImage Arrows(0),ImageWidth(Arrows(0))/2,ImageHeight(Arrows(0))/2
For i = 1 To 3
	Arrows(i)=CopyImage(Arrows(0))
	HandleImage Arrows(i), ImageWidth(Arrows(0))/2,ImageHeight(Arrows(0))/2
	RotateImage Arrows(i), i*90
Next


Const ClrR = 50, ClrG = 50, ClrB = 50

Dim SavedMaps$(30)
Global CurrMap$, SavePath$, Saved%

LoadSavedMaps()

Global FileLocation$ = "..\Data\rooms.ini"
Global FileLocationBoH$ = "..\BoxOfHorrors\Data\rooms.ini"


LoadRoomTemplates(FileLocation)
LoadRoomTemplates(FileLocationBoH)
Global SelectedRoomTemplate.RoomTemplates
Global SelectedX%, SelectedY%, RotateRoom%

InitEvents()

Global MapWidth% = GetINIInt("..\options.ini", "options", "map size"), MapHeight% = GetINIInt("..\options.ini", "options", "map size")
Dim Map.RoomTemplates(MapWidth, MapHeight)
Dim MapObj%(MapWidth,MapHeight)
Dim MapAngle%(MapWidth, MapHeight)
Dim MapEvent$(MapWidth, MapHeight)
Dim MapEventProb#(MapWidth, MapHeight)
;Dim MapAngle%(MapWidth, MapHeight)

Global RoomTemplateAmount = 0

For rt.RoomTemplates = Each RoomTemplates
	If rt\Name = "start" Then
		Map(MapWidth/2-1,MapHeight)=rt
		MapObj(MapWidth/2-1,MapHeight)=CopyEntity(rt\obj)
		EntityAlpha MapObj(MapWidth/2-1,MapHeight),1
		EntityAlpha GetChild(MapObj(MapWidth/2-1,MapHeight),1),0
		PositionEntity MapObj(MapWidth/2-1,MapHeight),(MapWidth/2-1)*8.0,0,MapHeight*8.0
		PositionEntity Camera,(MapWidth/2-1)*8.0,1,MapHeight*8.0
		MapEvent(MapWidth/2-1,MapHeight)="alarm"
		MapAngle(MapWidth/2-1,MapHeight)=180
		RotateEntity MapObj(MapWidth/2-1,MapHeight),0,MapAngle(MapWidth/2-1,MapHeight)+180,0
	EndIf
	RoomTemplateAmount = RoomTemplateAmount + 1
Next

Global MouseDown1%, MouseHit1%, MouseDown2%, MouseSpeedX#, MouseSpeedY#, MouseSpeedZ#, PrevMouseZ%
Global SelectedTextBox% = -1
Global TickIMG = LoadImage("tickimg.png")

strtemp$ = "aaaa"

ClsColor 0,0,0
Cls
CameraRange Camera,RoomScale,CamRange
CameraFogRange Camera,Max(0,CamRange-3.0),CamRange
RenderWorld
CopyRect 0,0,500,500,0,0,BackBuffer(),ImageBuffer(Render3D)

CheckFPS = MilliSecs()+1000

Repeat
	
	EntityAlpha CenterSphere,(SelectedRoomTemplate<>Null)
	
	If CheckFPS < MilliSecs() Then
		FPS = ElapsedLoops
		ElapsedLoops = 0
		CheckFPS = MilliSecs()+1000
	EndIf
	ElapsedLoops = ElapsedLoops+1
	
	If (D3DMode = 1) Then
		If FocusCamera Or ForceRender Then
			CamRange = Max(RoomScale,CamRange + (MouseSpeedZ*RoomScale*64.0))
			ClsColor 0,0,0
			Cls
			CameraRange Camera,RoomScale,CamRange
			CameraFogRange Camera,Max(0,CamRange-3.0),CamRange
			RenderWorld
			CopyRect 0,0,500,500,0,0,BackBuffer(),ImageBuffer(Render3D)
			ForceRender = False
			ClsColor ClrR,ClrG,ClrB
		EndIf
	EndIf
	
	Local x,y,width,height
	Local ScrollMenuY#, ScrollMenuHeight#
	
	MouseDown1 = MouseDown(1)
	MouseHit1 = MouseHit(1)
	MouseDown2 = MouseDown(2)
	MouseSpeedX# = MouseXSpeed()
	MouseSpeedY# = MouseYSpeed()
	MouseSpeedZ# = MouseZ()-PrevMouseZ
	
	PrevMouseZ%=MouseZ()
	
	Cls
	ClsColor ClrR, ClrG, ClrB
	
	x = 20
	y = 50
	width = 180
	height = 768-70
	TextBox (x,y,width,height,"")
	
	y = y-(ScrollMenuY#*RoomTemplateAmount*20)*0.5
	
	For rt.RoomTemplates = Each RoomTemplates
		If y > 40 And y < 30+height Then 
			If SelectedRoomTemplate = rt Then 
				Color 170, 170, 170
				Rect x+2,y+10,width-4,16
				Color 0,0,0
			EndIf			
			
			If MouseY()>y+9 And MouseY()<y+9+18 Then
				If MouseX()>x+1 And MouseX()<x+(width-1) Then
					Rect x+1,y+9,width-3,18,False
					If MouseHit1 Then
						PlaySound ButtonSFX
						If SelectedRoomTemplate = rt Then
							SelectedRoomTemplate = Null
						Else
							;If D3DMode = 1 Then ;3D Mode is activated
							Delay 8
							If SelectedX <> 0 Then
								EntityAlpha MapObj(SelectedX,SelectedY),1
								EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),0
							EndIf
							ForceRender = True
							;EndIf
							SelectedRoomTemplate = rt
							SelectedX=0
							SelectedY=0
						EndIf
					EndIf
				EndIf
			EndIf
			
			Text x+10, y+10, rt\Name
		EndIf
		y=y+18
	Next
	
	x = x+width+1
	y = 50
	width = 20
	
	;temp2 = MouseZSpeed()
	
	ScrollMenuY# = DrawScrollBar(x,y,width,height,x, y + ((height - ScrollMenuHeight) * ScrollMenuY),20,ScrollMenuHeight,ScrollMenuY,1)
	
	If MouseX()<x+width+2 Then
		ScrollMenuY# = Max(Min(ScrollMenuY-((MouseSpeedZ/height)*10.0),1.0),0.0)
	EndIf
	
	;If MouseOn(x, y + ((height - ScrollMenuHeight) * ScrollMenuY) - 5, width, ScrollMenuHeight) Then
	;	'	If MouseDown1 Then ScrollMenuY = Min(Max(ScrollMenuY + MouseYSpeed / (height - ScrollMenuHeight), 0), 1)
	;	'	
	;'EndIf
	ScrollMenuHeight = height/Max(RoomTemplateAmount,32)*32;height * ((height / 15) / Max(RoomTemplateAmount, height / 15)) ;' palkin korkeus	 
	
	x = 20+240
	y = 50
	width = 500
	height = 500
	TextBox (x,y,width,height,"")
	
	If D3DMode = 1 Then
		DrawBlock Render3D,x+2,y+2
		
		Local tempEnt%
		
		Color 255,255,255
		Text 5,5,"FPS: " + FPS
		
		If FocusCamera Then
			HidePointer ()
			
			Color 255,255,255
			Rect x+248,y+248,5,5,0
			Color 0,0,0
			Rect x+247,y+247,7,7,0
			Color 255,255,255
			
			CameraYaw = WrapAngle(CameraYaw-MouseX()+(GraphicsWidth()/2))
			CameraPitch = WrapAngle(CameraPitch+MouseY()-(GraphicsHeight()/2))
			RotateEntity Camera,CameraPitch,CameraYaw,0
			MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
			Text 5,25,"Press Esc to unfocus camera"
			If KeyDown(1) Then
				FocusCamera = False
				FlushKeys()
			EndIf
			Local speed# = RoomScale*10.0*(60.0/FPS)
			If KeyDown(42) Then ;lshift
				speed = speed*3
			Else If KeyDown(29) Then ;lctrl
				speed = speed/3
			EndIf
			If KeyDown(17) Then ;w
				MoveEntity Camera,0,0,speed
			Else If KeyDown(31) Then ;s
				MoveEntity Camera,0,0,-speed
			EndIf
			If KeyDown(30) Then ;a
				MoveEntity Camera,-speed,0,0
			Else If KeyDown(32) Then ;d
				MoveEntity Camera,speed,0,0
			EndIf
			Local surface%
			If MouseUp(1) Then
				tempEnt = CameraPick(Camera,250,250);x+250,y+250)
				If tempEnt <> 0 Then
					SelectedRoomTemplate = Null
					If EntityX(tempEnt,True)/8 <> MapWidth/2-1 Or EntityZ(tempEnt,True)/8 <> MapHeight Then
						If SelectedX <> 0 Then
							EntityAlpha MapObj(SelectedX,SelectedY),1
							EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),0
						EndIf
						SelectedX = EntityX(tempEnt,True)/8
						SelectedY = EntityZ(tempEnt,True)/8
						EntityAlpha MapObj(SelectedX,SelectedY),0
						EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),1
					EndIf
				Else
					If SelectedX <> 0 Then
						EntityAlpha MapObj(SelectedX,SelectedY),1
						EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),0
					EndIf
					SelectedX = 0
					SelectedY = 0
				EndIf
			EndIf
		Else
			ShowPointer()
		EndIf
		
	EndIf
	
	If Saved Then 
		Text x+width/2, y+15, CurrMap, True
	ElseIf CurrMap<>""
		Text x+width/2, y+15, CurrMap+"*", True
	EndIf
	
	If CurrMap <> "" Then 
		If Button (x+width/2-75, y+height-30, 150, 20, "Delete map", False) Then
			DebugLog CurrentDir()+"Maps\"+SavePath+".cbmap"
			If FileType(CurrentDir()+"Maps\"+SavePath+".cbmap")=1 Then 
				DeleteFile(CurrentDir()+"Maps\"+SavePath+".cbmap")
				SavePath = ""
				CurrMap = ""
				EraseMap()
				LoadSavedMaps()
				FlushPrevMouse()
				FlushMouse()
				PositionEntity Camera,(MapWidth/2-1)*8,1,MapHeight*8
				Delay 30
			EndIf
		EndIf
	EndIf
	
	If D3DMode = 0 Then
		x = x+(width/2)-(MapWidth*10)-10
		y = y+(height/2)-(MapHeight*10)-10
	
		Local mx%,my%,temp%,nx%,ny%
	
		For mx = 0 To MapWidth
			For my = 0 To MapHeight
				If SelectedX> 0 Then 
					If mx=SelectedX And my=SelectedY Then
						Color 200,200,200
						Rect(x + mx * 20+1, y + my * 20+1, 17, 17)
					EndIf
				EndIf			
			
				If Map(mx, my) = Null Then
					If mx=0 Or mx=MapWidth Or my=0 Or my = MapHeight Then
						Color 220, 220, 220
					Else
						Color 170, 170, 170
					EndIf
					
					Rect(x + mx * 20, y + my * 20, 19, 19,False)
				Else
					Color 0,0,0
					DrawImage(MapIcons(Map(mx,my)\Shape, Floor(MapAngle(mx,my)/90.0)), x + mx * 20 + 9, y + my * 20 + 9)
					Color 100,100,100
					If Map(mx,my)\Large Then Rect (x + mx * 20 - 9, y + my * 20 - 9, 38, 38,False)
					;Rect(x + mx * 20, y + my * 20, 19, 19,False)
				End If
			
				If MouseX()>x + mx * 20 And mx>0 And mx<MapWidth Then
					If MouseX()<x + mx * 20+19 Then
						If MouseY()>y + my * 20 And my > 0 And my < MapHeight Then
							If MouseY()<y + my * 20+19 Then
								Color 0,0,0
								Rect(x + mx * 20+1, y + my * 20+1, 17, 17,False)
							
								If MouseHit1 Then
									If SelectedRoomTemplate <> Null Then
										temp = True
										;don't allow placing two large rooms next to each other
										If SelectedRoomTemplate\Large Then 
											For nx = Max(mx-1,1) To Min(mx+1,MapWidth)
												For ny = Max(my-1,1) To Min(my+1,MapHeight)
													If Map(nx,ny)<>Null Then
														If Map(nx,ny)\Large Then temp = False : Exit
													EndIf
												Next
											Next
										EndIf
										
										If temp Then 
											Map(mx,my)=SelectedRoomTemplate
											MapEvent(mx,my)=""
											MapEventProb(mx,my)=1.0
											If MapObj(mx,my)<>0 Then
												FreeEntity GetChild(MapObj(mx,my),1)
												FreeEntity MapObj(mx,my)
											EndIf
											MapObj(mx,my)=CopyEntity(SelectedRoomTemplate\obj)
											EntityAlpha MapObj(mx,my),1
											EntityAlpha GetChild(MapObj(mx,my),1),0
											PositionEntity MapObj(mx,my),mx*8.0,0,my*8.0
											If Map(mx,my)\Shape <> ROOM2C
												RotateEntity MapObj(mx,my),0,MapAngle(mx,my)+180,0
											Else
												RotateEntity MapObj(mx,my),0,MapAngle(mx,my)+90,0
											EndIf
											Saved = False										
										EndIf
										
										
									Else
										SelectedRoomTemplate = Null
										If MapObj(SelectedX,SelectedY)<>0 Then
											EntityAlpha MapObj(SelectedX,SelectedY),1
											EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),0
										EndIf
										If Map(mx,my)<>Null Then 
											SelectedX = mx
											SelectedY = my
											If MapObj(SelectedX,SelectedY)<>0 Then
												EntityAlpha MapObj(SelectedX,SelectedY),0
												EntityAlpha GetChild(MapObj(SelectedX,SelectedY),1),1
											EndIf
											RotateRoom = True
										Else
											SelectedX=0
											SelectedY=0
										EndIf
									EndIf
								ElseIf MouseDown2
									Map(mx,my)=Null
									If MapObj(mx,my)<>0 Then
										FreeEntity GetChild(MapObj(mx,my),1)
										FreeEntity MapObj(mx,my)
									EndIf
									MapObj(mx,my)=0
									Saved = False
									If SelectedX = mx And SelectedY=my Then 
										SelectedX=0
										SelectedY=0
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			Next
		Next
		
		If MouseDown1 And Map(SelectedX, SelectedY)<>Null Then
			If RotateRoom Then 
				DrawImage Arrows(Floor(MapAngle(SelectedX, SelectedY)/90)), x + SelectedX*20 + 10, y + SelectedY*20 + 10
				
				If Distance(x + SelectedX*20 + 10, y + SelectedY*20 + 10, MouseX(), MouseY())>15 Then
					Saved = False
					MapAngle(SelectedX, SelectedY) = WrapAngle(Floor((GetAngle(x + SelectedX*20 + 10, y + SelectedY*20 + 10, MouseX(), MouseY())+45.0)/90.0)*90.0-90)
					If (Map(SelectedX,SelectedY)\Shape = ROOM2C) Then
						RotateEntity MapObj(SelectedX,SelectedY),0,MapAngle(SelectedX,SelectedY)+90,0,True
					Else
						RotateEntity MapObj(SelectedX,SelectedY),0,MapAngle(SelectedX,SelectedY)+180.0,0,True
					EndIf
				EndIf
			EndIf
		Else
			RotateRoom = False
		EndIf
	Else If D3DMode = 1 Then
		If MouseOn(x,y,width,height) Then
			If MouseUp(1) And (Not FocusCamera) Then
				FocusCamera = True
				MoveMouse GraphicsWidth()/2,GraphicsHeight()/2
			EndIf
		EndIf
	EndIf
	
	
	x = 20+240
	y = 570
	width = 500
	height = 768-590
	TextBox (x,y,width,height,"")
	
	;Local px%,py%
	Local placeable%
	Local placetext$
	
	If SelectedRoomTemplate <> Null Then
		px=Max(Min(EntityX(CenterSphere)/8,MapWidth),0.0)
		py=Max(Min(EntityZ(CenterSphere)/8,MapHeight),0.0)
		If px>0 And px<MapWidth And py>0 And py<MapHeight Then
			EntityColor CenterSphere,50,100,50
			placeable = True
		Else
			EntityColor CenterSphere,100,50,50
			placeable = False
		EndIf
		Text x+20, y+20, "Selected room template: "+SelectedRoomTemplate\Name
		Text x+20, y+50, SelectedRoomTemplate\Description
		
		If Map(px,py) <> Null And placeable Then
			placetext = "Replace ''"+Map(px,py)\Name+"'' with ''"+SelectedRoomTemplate\Name+"''"
		Else If placeable
			placetext = "Place ''"+SelectedRoomTemplate\Name+"''"
		Else
			placetext = "Can't place a room here!"
		EndIf
		
		If Button(x+20, y+80, 150,25, "Deselect") Then SelectedRoomTemplate = Null : EntityAlpha CenterSphere,0 : ForceRender = True
		
		If D3DMode = 1 Then
			If Button(x+20,y+120,250,25,placetext,(placetext="Can't place a room here!")) Then
				If placeable Then
					If MapObj(px,py) <> 0 Then
						FreeEntity MapObj(px,py)
						FreeEntity GetChild(MapObj(px,py),1)
						MapObj(px,py)=0
					EndIf
					MapEvent(px,py)=""
					MapEventProb(px,py)=0
					Map(px,py)=SelectedRoomTemplate
					MapObj(px,py)=CopyEntity(SelectedRoomTemplate\obj)
					EntityAlpha MapObj(px,py),1
					EntityAlpha GetChild(MapObj(px,py),1),0
					PositionEntity MapObj(px,py),px*8.0,0,py*8.0
					If Map(px,py)\Shape <> ROOM2C
						RotateEntity MapObj(px,py),0,MapAngle(px,py)+180,0
					Else
						RotateEntity MapObj(px,py),0,MapAngle(px,py)+90,0
					EndIf
					ForceRender = True
				EndIf
			EndIf
		EndIf
		If EntityX(CenterSphere) <> Int(EntityX(Camera)/8)*8 Or EntityZ(CenterSphere) <> Int(EntityZ(Camera)/8)*8 Then
			PositionEntity CenterSphere,Int(EntityX(Camera)/8)*8,0.5,Int(EntityZ(Camera)/8)*8
			EntityAlpha CenterSphere,1
			px=EntityX(CenterSphere)/8
			py=EntityZ(CenterSphere)/8
			If px>0 And px<MapWidth And py>0 And py<MapHeight Then
				EntityColor CenterSphere,50,100,50
			Else
				EntityColor CenterSphere,100,50,50
			EndIf
			ForceRender = True
		EndIf
		
	ElseIf SelectedX <> 0
		Text x+20, y+20, "Selected room: " +Map(SelectedX,SelectedY)\Name
		Text x+20, y+50, Map(SelectedX,SelectedY)\Description
		
		Text x+20, y+80, "Angle: "
		If Button(x+80, y+80-4, 20,20, "-") Then
			MapAngle(SelectedX,SelectedY)=WrapAngle(MapAngle(SelectedX,SelectedY)-90)
			TurnEntity MapObj(SelectedX,SelectedY),0,-90,0
			ForceRender = True
		EndIf
		Text x+130, y+80, MapAngle(SelectedX,SelectedY), True
		If Button(x+160, y+80-4, 20,20, "+") Then
			MapAngle(SelectedX,SelectedY)=WrapAngle(MapAngle(SelectedX,SelectedY)+90)
			TurnEntity MapObj(SelectedX,SelectedY),0,90,0
			ForceRender = True
		EndIf
		
		Text x+20, y+110, "Events: "
		y=y+110+20
		For i = 0 To 4
			If Map(SelectedX,SelectedY)\events[i]<>"" Then
				Text x+50, y, Map(SelectedX,SelectedY)\events[i]
				If Tick(x+20, y, (MapEvent(SelectedX,SelectedY)=Map(SelectedX,SelectedY)\events[i])) Then
					MapEvent(SelectedX,SelectedY)=Map(SelectedX,SelectedY)\events[i]
					If Button(x+240, y-4, 20,20, "-") Then 
						MapEventProb(SelectedX,SelectedY) = Max(MapEventProb(SelectedX,SelectedY)-0.1, 0.0)
						Saved = False
					EndIf
					Text x+335, y, "Probability: "+ MapEventProb(SelectedX,SelectedY), True
					If Button(x+410, y-4, 20,20, "+") Then 
						MapEventProb(SelectedX,SelectedY) = Min(MapEventProb(SelectedX,SelectedY)+0.1, 1.0)		
						Saved = False
					EndIf
				Else
					If MapEvent(SelectedX,SelectedY)=Map(SelectedX,SelectedY)\events[i] Then MapEvent(SelectedX,SelectedY)=""
				EndIf
				
				y=y+20
			EndIf
		Next
		
		x = 260
		y = 570
		
		If D3DMode = 1 Then
			
			If Button(x+300,y+75-4,100,20,"Remove room") Then
				FreeEntity MapObj(SelectedX,SelectedY)
				MapObj(SelectedX,SelectedY)=0
				Map(SelectedX,SelectedY)=Null
				MapEvent(SelectedX,SelectedY)=""
				MapEventProb(SelectedX,SelectedY)=0
				MapAngle(SelectedX,SelectedY)=0
				SelectedX=0
				SelectedY=0
				ForceRender = True
				Saved = False
			EndIf
			
		Else
			
			If Button(x+230,y+75-4,200,20,"Move camera to this room") Then
				PositionEntity Camera,SelectedX*8,1,SelectedY*8,True
			EndIf
		EndIf
		
	EndIf
	
	x = x + width + 40
	y = 50
	width = 1024 - x - 20
	height = 500
	TextBox (x,y,width,height,"")
	
	
	Text x+20,y+20,"Saved maps: "
	y=y+40
	For i = 0 To 20
		If SavedMaps(i)<>"" Then
			If CurrMap = SavedMaps(i) Then 
				Color 170, 170, 170
				Rect x+2,y,width-4,20
				Color 0,0,0
				If Saved Then 
					Text x+20, y+2, SavedMaps(i)
				Else
					Text x+20, y+2, SavedMaps(i)+"*"	
				EndIf
			Else
				Text x+20, y+2, SavedMaps(i)
			EndIf
			
			
			If MouseX()>x And MouseX()<x+width Then
				If MouseY()> y And MouseY()<y+19 Then
					Rect x+1,y,width-3,20,False
					If MouseHit1 Then 
						PlaySound ButtonSFX
						SavePath = SavedMaps(i)
						CurrMap = SavePath
						LoadMap("Maps\"+SavedMaps(i))
						Delay 8
					EndIf
				EndIf
			EndIf			
			y=y+20
		EndIf
	Next
	
	If Button(GraphicsWidth()/2-100,10,200,20,"Create new map") Then
		SavePath = ""
		CurrMap = ""
		EraseMap()
		LoadSavedMaps()
		FlushPrevMouse()
		FlushMouse()
		PositionEntity Camera,(MapWidth/2-1)*8.0,1,MapHeight*8.0
	EndIf
	
	;y = 15
	;For R.RaceTemplates = Each RaceTemplates
		;If Tick(320, y, (SelectedRace = r.racetemplates)) Then
		;	SelectedRace = r.racetemplates
		;EndIf
		;Text 345, y, r\name
		;y = y + 20
	;Next
	

	;Text 10, 180, "NPC size (in 16*16 map blocks): "
	;If Button(10, 200, 20,20, "-") Then SelectedRace\SpriteWidth = Max(SelectedRace\SpriteWidth-1,0)
	;TextBox(30, 200, 20,20, SelectedRace\SpriteWidth)
	;If Button(50, 200, 20,20, "+") Then SelectedRace\SpriteWidth = Min(SelectedRace\SpriteWidth+1,8)
	;Text 80, 203, "X", True
	;If Button(90, 200, 20,20, "-") Then SelectedRace\SpriteHeight = Max(SelectedRace\SpriteHeight-1,0)
	;TextBox(110, 200, 20,20, SelectedRace\SpriteHeight)
	;If Button(130, 200, 20,20, "+") Then SelectedRace\SpriteHeight = Min(SelectedRace\SpriteHeight+1,8)	
	
	
	;Text 10, 230, "Minimum strength: "+ SelectedRace\MinStrength
	;SelectedRace\MinStrength = Min(SlideBar(180,237,100,SelectedRace\MinStrength*2)/2,SelectedRace\MaxStrength)
	;Text 10, 250, "Maximum strength: "+ SelectedRace\MaxStrength
	;SelectedRace\MaxStrength = Max(SlideBar(180,257,100,SelectedRace\MaxStrength*2)/2, SelectedRace\MinStrength)

	;If Button(200,670,100,20,"Delete NPC") Then 
		;DeleteSection(FileLocation, SelectedRace\Name)
	;EndIf
	
	;x = x
	y = 50+550 - 20
	width = 1024 - x - 20
	height = 25
	
	If Button(x,y,width,height, "Save", (CurrMap="")) Then
		SaveMap("Maps\"+CurrMap)
	EndIf	
	
	y = y + 40
	
	If Button(x,y,width,height, "Save as "+SavePath+"", (SavePath="")) Then
		If CurrMap = "" Then CurrMap = SavePath
		SaveMap("Maps\"+SavePath)
		LoadSavedMaps()
	EndIf
	
	If (Not FocusCamera) Then
		SavePath$ = Left(InputBox(x,y+25,width,height,SavePath),15)
	Else
		TextBox(x,y+25,width,height,SavePath)
	EndIf
	
	Local tempButtonStr$=""
	If D3DMode = 1 Then
		tempButtonStr="3D Mode"
	Else
		tempButtonStr="2D Mode"
	EndIf
	
	y=y+80
	
	If Button(x,y,width,height,tempButtonStr) Then
		D3DMode = Not D3DMode
		ForceRender=True
	EndIf
	
	If Button(x+width/2, 15, width/2, height, "QUIT") Then End
	
	Flip
	
	PrevMouseDown(1)=Max(Min(5,(MouseDown(1)*2)-1+PrevMouseDown(1)),0) ;there's a delay for those with
	PrevMouseDown(2)=Max(Min(5,(MouseDown(2)*2)-1+PrevMouseDown(2)),0) ;slower computers, so they can
	PrevMouseDown(3)=Max(Min(5,(MouseDown(3)*2)-1+PrevMouseDown(3)),0) ;use MouseUp easily too.
	
	;Delay 8
Forever

Function Button%(x,y,width,height,txt$, disabled%=False)
	Local Pushed = False
	
	Color ClrR, ClrG, ClrB
	If Not disabled Then 
		If MouseX() > x And MouseX() < x+width Then
			If MouseY() > y And MouseY() < y+height Then
				If MouseDown1 Then
					Pushed = True
					Color ClrR*0.6, ClrG*0.6, ClrB*0.6
				Else
					Color Min(ClrR*1.2,255),Min(ClrR*1.2,255),Min(ClrR*1.2,255)
				EndIf
			EndIf
		EndIf
	EndIf
	
	If Pushed Then 
		Rect x,y,width,height
		Color 133,130,125
		Rect x+1,y+1,width-1,height-1,False	
		Color 10,10,10
		Rect x,y,width,height,False
		Color 250,250,250
		Line x,y+height-1,x+width-1,y+height-1
		Line x+width-1,y,x+width-1,y+height-1
	Else
		Rect x,y,width,height
		Color 133,130,125
		Rect x,y,width-1,height-1,False	
		Color 250,250,250
		Rect x,y,width,height,False
		Color 10,10,10
		Line x,y+height-1,x+width-1,y+height-1
		Line x+width-1,y,x+width-1,y+height-1		
	EndIf
	
	Color 255,255,255
	If disabled Then Color 70,70,70
	Text x+width/2, y+height/2-1, txt, True, True
	
	Color 0,0,0
	
	If Pushed And MouseHit1 Then PlaySound ButtonSFX : Return True
End Function

Function Tick(x,y,selected%)
	TextBox(x,y,13,13,"")
	
	If selected Then
		DrawImage TickIMG, x, y
	EndIf
	
	If MouseX() > x And MouseX() < x+13 Then
		If MouseY() > y And MouseY() < y+13 Then
			If MouseHit1 Then PlaySound ButtonSFX : Return (Not selected)
		EndIf
	EndIf	
	
	Return selected
	
End Function

Function InputBox$(x,y,width,height,Txt$,ID=0)
	TextBox(x,y,width,height,Txt$)
	
	Local MouseOnBox = False
	
	If MouseX() > x And MouseX() < x+width Then
		If MouseY() > y And MouseY() < y+height Then
			MouseOnBox = True
			If MouseHit1 Then SelectedTextBox = ID : FlushKeys
		EndIf
	EndIf	
	
	If MouseOnBox = False And MouseHit1 And SelectedTextBox = ID Then SelectedTextBox = -1
	
	If SelectedTextBox = ID Then
		Txt = rInput(Txt)
		Color 0,0,0
		If (MilliSecs() Mod 800) < 400 Then  Rect x+width/2 + StringWidth(Txt)/2 + 2, y+height/2-5, 2, 12
	EndIf
	
	Return Txt
End Function

Function TextBox(x,y,width,height,Txt$)
	Color 255,255,255
	Rect x,y,width,height
	
	Color 128,128,128
	Rect x,y,width,height,False
	Color 64,64,64
	Rect x+1,y+1,width-2,height-2,False	
	Color 255,255,255
	Line x+width-1,y,x+width-1, y+height-1
	Line x, y+height-1, x+width-1, y+height-1	
	Color 212, 208, 199
	Line x+width-2,y+1,x+width-2, y+height-2
	Line x+1, y+height-2, x+width-2, y+height-2
	
	Color 0,0,0
	Text x+width/2, y+height/2, Txt, True, True
End Function

Function rInput$(aString$)
	value = GetKey()
	length = Len(aString$)
	If value = 8 Then value = 0 :If length > 0 Then aString$ = Left$(aString,Length-1)
	If value = 13 Then Goto ende
	If value = 0 Then Goto ende
	If value>0 And value<7 Or value>26 And value<32 Or value=9 Then Goto ende
	aString$=aString$ + Chr$(value)
	.ende
	Return aString$
End Function

Function SlideBar#(x, y, leveys, arvo)
	
	If MouseDown(1) Then
		If MouseX() >= x-5 And MouseX() <= x+leveys+15 And MouseY() >= y-5 And MouseY() <= y+5 Then
			arvo = Min(Max((MouseX()-x-5)*100/leveys, 0), 100)
		EndIf
	EndIf
	
	TextBox(x, y-5, leveys+10, 10, "")
	
	Button(x + leveys*arvo/100, y-5, 10, 11, "")
	
	Return arvo
	
End Function


Function DrawScrollBar#(x, y, width, height, barx, bary, barwidth, barheight, bar#, dir = 0)
	;0 = vaakasuuntainen, 1 = pystysuuntainen
	
	Color(0, 0, 0)
	Rect(x, y, width, height)
	Button(barx, bary, barwidth, barheight, "")
	
	If dir = 0 Then ;vaakasuunnassa
		If height > 10 Then
			Color 250,250,250
			Rect(barx + barwidth / 2, bary + 5, 2, barheight - 10)
			Rect(barx + barwidth / 2 - 3, bary + 5, 2, barheight - 10)
			Rect(barx + barwidth / 2 + 3, bary + 5, 2, barheight - 10)
		EndIf
	Else ;pystysuunnassa
		If width > 10 Then
			Color 250,250,250
			Rect(barx + 4, bary + barheight / 2, barwidth - 10, 2)
			Rect(barx + 4, bary + barheight / 2 - 3, barwidth - 10, 2)
			Rect(barx + 4, bary + barheight / 2 + 3, barwidth - 10, 2)
		EndIf
	EndIf
	
	If MouseDown1 Then
		If MouseX()>barx And MouseX()<barx+barwidth Then
			If MouseY()>bary And MouseY()<bary+barheight Then
				If dir = 0 Then
					Return Min(Max(bar + MouseSpeedX / Float(width - barwidth), 0), 1)
				Else
					Return Min(Max(bar + MouseSpeedY / Float(height - barheight), 0), 1)
				End If				
			EndIf
		EndIf
	End If
	
	Return bar

End Function



Function SaveMap(file$)
	f% = WriteFile(file+".cbmap")
	
	For x = 0 To MapWidth
		For y = 0 To MapHeight
			If Map(x,y)<>Null Then
				WriteByte f, x
				WriteByte f, y
				WriteString f, Lower(Map(x,y)\Name)
				WriteByte f, Floor(MapAngle(x,y)/90.0)
				WriteString f, MapEvent(x,y)
				WriteFloat f, MapEventProb(x,y)
			EndIf
		Next
	Next
	
	Saved = True
	
	CloseFile f
End Function

Function LoadMap(file$)
	EraseMap()
	
	Local brush%
	
	f% = ReadFile(file+".cbmap")
	DebugLog file+".cbmap"
	
	While Not Eof(f)
		DebugLog "dsfkjmgndfklmgkl"
		x = ReadByte(f)
		y = ReadByte(f)
		name$ = ReadString(f)
		DebugLog x+", "+y+": "+name
		For rt.roomtemplates=Each RoomTemplates
			If Lower(rt\name) = name Then
				DebugLog rt\name
				Map(x,y)=rt
				If MapObj(x,y) = 0 Then MapObj(x,y)=CopyEntity(rt\obj)
				Exit
			EndIf
		Next
		MapAngle(x,y)=ReadByte(f)*90
		MapEvent(x,y) = ReadString(f)
		MapEventProb(x,y) = ReadFloat(f)
		EntityPickMode MapObj(x,y),2
		PositionEntity MapObj(x,y),x*8.0,0,y*8.0
		EntityAlpha MapObj(x,y),1
		EntityAlpha GetChild(MapObj(x,y),1),0
		If Map(x,y)\Shape <> ROOM2C
			RotateEntity MapObj(x,y),0,MapAngle(x,y)+180,0
		Else
			RotateEntity MapObj(x,y),0,MapAngle(x,y)+90,0
		EndIf
	Wend
	
	Saved = True
	
	CloseFile f
	PositionEntity Camera,(MapWidth/2-1)*8.0,1,MapHeight*8.0
End Function

Function LoadSavedMaps()
	
	For i = 0 To 20
		SavedMaps(i)=""
	Next
	
	myDir=ReadDir(CurrentDir()+"\Maps") 
	i = 0
	Repeat 
		file$=NextFile$(myDir)
		DebugLog file
		If file$="" Then Exit 
		If FileType("Maps\"+file$) = 1 Then 
			If file <> "." And file <> ".." Then 
				SavedMaps(i) = Left(file,Max(Len(file)-6,1))
				i=i+1
			EndIf
		End If 
	Forever 
	CloseDir myDir 
	
End Function


Function EraseMap()
	SelectedX = 0
	SelectedY = 0
	SelectedRoomTemplate = Null
	
	For x = 1 To MapWidth-1
		For y = 1 To MapHeight-1
			Map(x,y)=Null
			FreeEntity MapObj(x,y)
			MapObj(x,y)=0
			MapAngle(x,y)=0
			MapEvent(x,y)=""
			MapEventProb(x,y)=0.0
		Next
	Next
	ForceRender=True
End Function

;INI-funktiot:
Function GetINIString$(file$, section$, parameter$)
	
	DebugLog file
	
	Local TemporaryString$ = ""
	Local f = ReadFile(file)
	
	While Not Eof(f)
		If ReadLine(f) = "["+section+"]" Then
			Repeat 
				TemporaryString = ReadLine(f)
				If Trim( Left(TemporaryString, Max(Instr(TemporaryString,"=")-1,0)) ) = parameter Then
					CloseFile f
					Return Trim( Right(TemporaryString,Len(TemporaryString)-Instr(TemporaryString,"=")) )
				EndIf
			Until Left(TemporaryString,1) = "[" Or Eof(f)
			CloseFile f
			Return ""
		EndIf
	Wend
	
	CloseFile f
End Function

Function GetINIInt%(file$, section$, parameter$)
	Local strtemp$ = Lower(GetINIString(file$, section$, parameter$))
	
	Select strtemp
		Case "true"
			Return 1
		Case "false"
			Return 0
		Default
			Return Int(strtemp)
	End Select
	Return 
End Function

Function GetINIFloat#(file$, section$, parameter$)
	Return GetINIString(file$, section$, parameter$)
End Function


; matemaattiset funktiot:
Function Min#(a#,b#)
	If a < b Then Return a Else Return b
End Function

Function Max#(a#,b#)
	If a > b Then Return a Else Return b
End Function

Function WrapAngle#(angle#)
	While angle < 0
		angle = angle + 360
	Wend 
	While angle >= 360
		angle = angle - 360
	Wend
	Return angle
End Function

Function GetAngle#(x1#, y1#, x2#, y2#)
	Return ATan2( y2 - y1, x2 - x1 )
End Function

Function Distance#(x1#, y1#, x2#, y2#)
	Return(Sqr(((x2 - x1) * (x2 - x1)) + ((y2 - y1) * (y2 - y1))))
End Function


Function PutINIValue%(INI_sAppName$, INI_sSection$, INI_sKey$, INI_sValue$)
	
; Returns: True (Success) or False (Failed)
	
	INI_sSection = "[" + Trim$(INI_sSection) + "]"
	INI_sUpperSection$ = Upper$(INI_sSection)
	INI_sKey = Trim$(INI_sKey)
	INI_sValue = Trim$(INI_sValue)
	INI_sFilename$ = CurrentDir$() + "\"  + INI_sAppName
	
; Retrieve the INI data (if it exists)
	
	INI_sContents$= INI_FileToString(INI_sFilename)
	
; (Re)Create the INI file updating/adding the SECTION, KEY and VALUE
	
	INI_bWrittenKey% = False
	INI_bSectionFound% = False
	INI_sCurrentSection$ = ""
	
	INI_lFileHandle = WriteFile(INI_sFilename)
	If INI_lFileHandle = 0 Then Return False ; Create file failed!
	
	INI_lOldPos% = 1
	INI_lPos% = Instr(INI_sContents, Chr$(0))
	
	While (INI_lPos <> 0)
		
		INI_sTemp$ =Trim$(Mid$(INI_sContents, INI_lOldPos, (INI_lPos - INI_lOldPos)))
		
		If (INI_sTemp <> "") Then
			
			If Left$(INI_sTemp, 1) = "[" And Right$(INI_sTemp, 1) = "]" Then
				
				; Process SECTION
				
				If (INI_sCurrentSection = INI_sUpperSection) And (INI_bWrittenKey = False) Then
					INI_bWrittenKey = INI_CreateKey(INI_lFileHandle, INI_sKey, INI_sValue)
				End If
				INI_sCurrentSection = Upper$(INI_CreateSection(INI_lFileHandle, INI_sTemp))
				If (INI_sCurrentSection = INI_sUpperSection) Then INI_bSectionFound = True
				
			Else
				
				; KEY=VALUE
				
				lEqualsPos% = Instr(INI_sTemp, "=")
				If (lEqualsPos <> 0) Then
					If (INI_sCurrentSection = INI_sUpperSection) And (Upper$(Trim$(Left$(INI_sTemp, (lEqualsPos - 1)))) = Upper$(INI_sKey)) Then
						If (INI_sValue <> "") Then INI_CreateKey INI_lFileHandle, INI_sKey, INI_sValue
						INI_bWrittenKey = True
					Else
						WriteLine INI_lFileHandle, INI_sTemp
					End If
				End If
				
			End If
			
		End If
		
		; Move through the INI file...
		
		INI_lOldPos = INI_lPos + 1
		INI_lPos% = Instr(INI_sContents, Chr$(0), INI_lOldPos)
		
	Wend
	
	; KEY wasn't found in the INI file - Append a new SECTION if required and create our KEY=VALUE line
	
	If (INI_bWrittenKey = False) Then
		If (INI_bSectionFound = False) Then INI_CreateSection INI_lFileHandle, INI_sSection
		INI_CreateKey INI_lFileHandle, INI_sKey, INI_sValue
	End If
	
	CloseFile INI_lFileHandle
	
	Return True ; Success
	
End Function

Function INI_FileToString$(INI_sFilename$)
	
	INI_sString$ = ""
	INI_lFileHandle% = ReadFile(INI_sFilename)
	If INI_lFileHandle <> 0 Then
		While Not(Eof(INI_lFileHandle))
			INI_sString = INI_sString + ReadLine$(INI_lFileHandle) + Chr$(0)
		Wend
		CloseFile INI_lFileHandle
	End If
	Return INI_sString
	
End Function

Function INI_CreateSection$(INI_lFileHandle%, INI_sNewSection$)
	
	If FilePos(INI_lFileHandle) <> 0 Then WriteLine INI_lFileHandle, "" ; Blank line between sections
	WriteLine INI_lFileHandle, INI_sNewSection
	Return INI_sNewSection
	
End Function

Function INI_CreateKey%(INI_lFileHandle%, INI_sKey$, INI_sValue$)
	
	WriteLine INI_lFileHandle, INI_sKey + "=" + INI_sValue
	Return True
	
End Function

Function LoadRoomMesh(room_name$,mesh_path$)
	
	Local tempmesh% = LoadAnimMesh(mesh_path)
	
	Local newmesh% = CreateMesh()
	
	Local selectedMesh%
	
	Local terrain%
	
	;CopyMesh
	
	For c=1 To CountChildren(tempmesh)
		
		Local node=GetChild(tempmesh,c)	
		Local classname$=Lower(KeyValue(node,"classname"))
		
		Select classname
			Case "mesh"
				ScaleMesh node,EntityScaleX(node),EntityScaleY(node),EntityScaleZ(node)
				RotateMesh node,EntityPitch(node),EntityYaw(node),EntityRoll(node)
				PositionMesh node,EntityX(node),EntityY(node),EntityZ(node)
				AddMesh node,newmesh
			Case "brush"
				RotateMesh node,EntityPitch(node),EntityYaw(node),EntityRoll(node)
				PositionMesh node,EntityX(node),EntityY(node),EntityZ(node)
				AddMesh node,newmesh
		End Select
		
	Next
	
	Select room_name
		Case "exit1"
			DebugLog("exit1terrain.b3d")
			terrain = LoadMesh("..\GFX\map\exit1terrain.b3d")
			PositionMesh terrain, 4356.0, 9767.0, 2588.0
			AddMesh terrain,newmesh
			FreeEntity terrain
			terrain = 0
	End Select
	
	;EntityFX newmesh,1
	
	selectedMesh = CopyMesh(newmesh,newmesh)
	
	For c=1 To CountSurfaces(selectedMesh)
		surface = GetSurface(selectedMesh,c)
		For d=0 To CountVertices(surface)-1
			VertexColor surface,d,(VertexRed(surface,d)/255)*150,(VertexGreen(surface,d)/255)*255,(VertexBlue(surface,d)/255)*150,VertexAlpha(surface,d)
		Next
	Next
	
	;HideEntity selectedMesh
	
	FreeEntity tempmesh
	
	Return newmesh
	
End Function

;RMESH STUFF;;;;

Type Materials
	Field name$
	Field Diff
	Field Bump
	
	Field StepSound%
End Type

Function StripFilename$(file$)
	Local mi$=""
	Local lastSlash%=0
	If Len(file)>0
		For i%=1 To Len(file)
			mi=Mid(file$,i,1)
			If mi="\" Or mi="/" Then
				lastSlash=i
			EndIf
		Next
	EndIf
	
	Return Left(file,lastSlash)
End Function

Function StripPath$(file$) 
	
	If Len(file$)>0 
		
		For i=Len(file$) To 1 Step -1 
			
			mi$=Mid$(file$,i,1) 
			If mi$="\" Or mi$="/" Then Return name$ Else name$=mi$+name$ 
			
		Next 
		
	EndIf 
	
	Return name$ 
	
End Function 

Function GetTextureFromCache%(name$)
	For tc.Materials=Each Materials
		If tc\name = name Then Return tc\Diff
	Next
	Return 0
End Function

;Function GetBumpFromCache%(name$)
;	For tc.Materials=Each Materials
;		If tc\name = name Then Return tc\Bump
;	Next
;	Return 0
;End Function

Function GetCache.Materials(name$)
	For tc.Materials=Each Materials
		If tc\name = name Then Return tc
	Next
	Return Null
End Function

Function AddTextureToCache(texture%)
	Local tc.Materials=GetCache(StripPath(TextureName(texture)))
	If tc.Materials=Null Then
		tc.Materials=New Materials
		tc\name=StripPath(TextureName(texture))
		;Local temp$=GetINIString("..\Data\materials.ini",tc\name,"bump")
		;If temp<>"" Then
		;	tc\Bump=LoadTexture(temp)
		;	TextureBlend tc\Bump,FE_BUMP
		;Else
		;	tc\Bump=0
		;EndIf
		tc\Diff=0
	EndIf
	If tc\Diff=0 Then tc\Diff=texture
End Function

Function ClearTextureCache()
	For tc.Materials=Each Materials
		If tc\Diff<>0 Then FreeTexture tc\Diff
		If tc\Bump<>0 Then FreeTexture tc\Bump
		Delete tc
	Next
End Function

Function FreeTextureCache()
	For tc.Materials=Each Materials
		If tc\Diff<>0 Then FreeTexture tc\Diff
		If tc\Bump<>0 Then FreeTexture tc\Bump
		tc\Diff = 0 : tc\Bump = 0
	Next
End Function

Function LoadRoomMeshNew(room_name$,file$)
	;generate a texture made of white
	Local blankTexture%
	blankTexture=CreateTexture(4,4,1,1)
	ClsColor 255,255,255
	SetBuffer TextureBuffer(blankTexture)
	Cls
	SetBuffer BackBuffer()
	ClsColor 0,0,0
	
	;read the file
	Local f%=ReadFile(file)
	Local i%,j%,k%,x#,y#,z#,yaw#
	Local vertex%
	Local temp1i%,temp2i%,temp3i%
	Local temp1#,temp2#,temp3#
	Local temp1s$
	For i=0 To 3 ;reattempt up to 3 times
		If f=0 Then
			Delay 8
			f=ReadFile(file)
		Else
			Exit
		EndIf
	Next
	If f=0 Then RuntimeError "Error reading file "+Chr(34)+file+Chr(34)
	If ReadString(f)<>"RoomMesh" Then RuntimeError Chr(34)+file+Chr(34)+" is not RMESH"
	
	file=StripFilename(file)
	
	Local count%,count2%
	;drawn meshes
	
	Local Opaque%,Alpha%
	
	Opaque=CreateMesh()
	Alpha=CreateMesh()
	
	count = ReadInt(f)
	Local childMesh%
	Local surf%,tex%[2],brush%
	
	Local isAlpha%
	
	Local u#,v#
	
	For i=1 To count ;drawn mesh
		childMesh=CreateMesh()
		
		surf=CreateSurface(childMesh)
		
		brush=CreateBrush()
		
		tex[0]=0 : tex[1]=0
		
		isAlpha=0
		For j=0 To 1
			temp1i=ReadByte(f)
			If temp1i<>0 Then
				temp1s=ReadString(f)
				tex[j]=GetTextureFromCache(temp1s)
				If tex[j]=0 Then ;texture is not in cache
					Select True
						Case temp1i<3
							tex[j]=LoadTexture(file+temp1s,1)
						Default
							tex[j]=LoadTexture(file+temp1s,3)
					End Select
					
					If tex[j]<>0 Then
						If temp1i=1 Then TextureBlend tex[j],5
						AddTextureToCache(tex[j])
					EndIf
					
				EndIf
				If tex[j]<>0 Then
					isAlpha=2
					If temp1i=3 Then isAlpha=1
					
					TextureCoords tex[j],1-j
				EndIf
			EndIf
		Next
		
		If isAlpha=1 Then
			If tex[1]<>0 Then
				TextureBlend tex[1],2
				BrushTexture brush,tex[1],0,0
			Else
				BrushTexture brush,blankTexture,0,0
			EndIf
		Else
			
			For j=0 To 1
				If tex[j]<>0 Then
					BrushTexture brush,tex[j],0,j
				Else
					BrushTexture brush,blankTexture,0,j
				EndIf
			Next
			
		EndIf
		
		surf=CreateSurface(childMesh)
		
		If isAlpha>0 Then PaintSurface surf,brush
		
		FreeBrush brush : brush = 0
		
		count2=ReadInt(f) ;vertices
		
		For j%=1 To count2
			;world coords
			x=ReadFloat(f) : y=ReadFloat(f) : z=ReadFloat(f)
			vertex=AddVertex(surf,x,y,z)
			
			;texture coords
			For k%=0 To 1
				u=ReadFloat(f) : v=ReadFloat(f)
				VertexTexCoords surf,vertex,u,v,0.0,k
			Next
			
			;colors
			temp1i=ReadByte(f)
			temp2i=ReadByte(f)
			temp3i=ReadByte(f)
			VertexColor surf,vertex,temp1i,temp2i,temp3i,1.0
		Next
		
		count2=ReadInt(f) ;polys
		For j%=1 To count2
			temp1i = ReadInt(f) : temp2i = ReadInt(f) : temp3i = ReadInt(f)
			AddTriangle(surf,temp1i,temp2i,temp3i)
		Next
		
		If isAlpha=1 Then
			AddMesh childMesh,Alpha
		Else
			AddMesh childMesh,Opaque
		EndIf
		;EntityParent childMesh,Opaque
		;EntityAlpha childMesh,0.0
		;EntityType childMesh,HIT_MAP
		;EntityPickMode childMesh,2
		
		FreeEntity childMesh
		
	Next
	
	temp1i=CopyMesh(Alpha)
	FlipMesh temp1i
	AddMesh temp1i,Alpha
	FreeEntity temp1i
	
	If brush <> 0 Then FreeBrush brush
	
	AddMesh Alpha,Opaque
	FreeEntity Alpha
	
	EntityFX Opaque,3
	
	FreeTexture blankTexture
	
	Select room_name
		Case "exit1"
			DebugLog("exit1terrain.b3d")
			terrain = LoadMesh("..\GFX\map\exit1terrain.b3d")
			PositionMesh terrain, 4356.0, 9767.0, 2588.0
			AddMesh terrain,Opaque
			FreeEntity terrain
			terrain = 0
	End Select
	
	selectedMesh = CopyMesh(Opaque,Opaque)
	
	For c=1 To CountSurfaces(selectedMesh)
		surf = GetSurface(selectedMesh,c)
		For d=0 To CountVertices(surf)-1
			VertexColor surf,d,(VertexRed(surf,d)/255)*150,(VertexGreen(surf,d)/255)*255,(VertexBlue(surf,d)/255)*150,VertexAlpha(surf,d)
		Next
	Next
	
	EntityFX selectedMesh,3
	
	;HideEntity selectedMesh
	
	Return Opaque
	
End Function


Function Piece$(s$,entry,char$=" ")
	While Instr(s,char+char)
		s=Replace(s,char+char,char)
	Wend
	For n=1 To entry-1
		p=Instr(s,char)
		s=Right(s,Len(s)-p)
	Next
	p=Instr(s,char)
	If p<1
		a$=s
	Else
		a=Left(s,p-1)
	EndIf
	Return a
End Function

Function KeyValue$(entity,key$,defaultvalue$="")
	properties$=EntityName(entity)
	properties$=Replace(properties$,Chr(13),"")
	key$=Lower(key)
	Repeat
		p=Instr(properties,Chr(10))
		If p Then test$=(Left(properties,p-1)) Else test=properties
		testkey$=Piece(test,1,"=")
		testkey=Trim(testkey)
		testkey=Replace(testkey,Chr(34),"")
		testkey=Lower(testkey)
		If testkey=key Then
			value$=Piece(test,2,"=")
			value$=Trim(value$)
			value$=Replace(value$,Chr(34),"")
			Return value
		EndIf
		If Not p Then Return defaultvalue$
		properties=Right(properties,Len(properties)-p)
	Forever 
End Function

Function MouseOn%(x%,y%,width%,height%)
	
	If MouseX() >= x And MouseY() >= y Then
		If MouseX() <= x+width And MouseY() <= y+height Then
			Return True
		Else
			Return False
		EndIf
	Else
		Return False
	EndIf
	
End Function

Function MouseUp(a%)
	If PrevMouseDown(a) = True And MouseDown(a) = False Then
		Return True
	Else
		Return False
	EndIf
End Function

Function FlushPrevMouse()
	PrevMouseDown(1) = False
	PrevMouseDown(2) = False
	PrevMouseDown(3) = False
End Function

Function EntityScaleX#(entity, globl=False) 
	If globl Then TFormVector 1,0,0,entity,0 Else TFormVector 1,0,0,entity,GetParent(entity) 
	Return Sqr(TFormedX()*TFormedX()+TFormedY()*TFormedY()+TFormedZ()*TFormedZ()) 
End Function 

Function EntityScaleY#(entity, globl=False)
	If globl Then TFormVector 0,1,0,entity,0 Else TFormVector 0,1,0,entity,GetParent(entity)  
	Return Sqr(TFormedX()*TFormedX()+TFormedY()*TFormedY()+TFormedZ()*TFormedZ()) 
End Function 

Function EntityScaleZ#(entity, globl=False)
	If globl Then TFormVector 0,0,1,entity,0 Else TFormVector 0,0,1,entity,GetParent(entity)  
	Return Sqr(TFormedX()*TFormedX()+TFormedY()*TFormedY()+TFormedZ()*TFormedZ()) 
End Function
;~IDEal Editor Parameters:
;~F#37#40C#434#447#453#48D#4CC#50F#51D#523#527#52B#535#539#53E#58E#59C#5A4#5E9#5F1
;~F#600#611#61F#626#637#63F#706#717#72D#73B#743#749#74E#753
;~C#Blitz3D